#pragma  once

/***********************************************************************
**ܣº,ǷºӵĻ
**ߣ                                                                   
***********************************************************************/
template <class Arg, class Result>
struct _unary_function{
	typedef Arg argument_type;
	typedef Result result_type;
};

template <class Arg1, class Arg2, class Result>
struct _binary_function{
	typedef Arg1 first_argument_type;
	typedef Arg2 second_argument_type;
	typedef Result result_type;
};

/***********************************************************************
**ܣȽϴС
**ߣ                                                                   
***********************************************************************/
template <class T>
struct _less : public _binary_function <T, T, bool>{//ķͶ˲ͺͷ
	bool operator()(const T& x, const T& y)const{return x<y;}
};



/***********************************************************************
**ܣº 󶨵ڶ һӵ
**ߣ                                                                   
***********************************************************************/
template <class Operation>
//_binder2ndĲͺͷͣĿǸãʹǶʹ
class _binder2nd : public  _unary_function<typename Operation::first_argument_type,typename Operation::result_type>{
protected:
	Operation op;
	typename Operation::second_argument_type value;//ȡϢ
public:
	_binder2nd(const Operation &x, const typename Operation::second_argument_type &y):op(x),value(y){}

	typename Operation::result_type operator()(const typename Operation::first_argument_type &x )const{//ʵҲһº,ֻǹ̶˵ڶķº
		return op(x, value);//ﺯķ͸ӵķºһ
	}
};

template <class Operation, class T>
inline _binder2nd<Operation>_bind2nd(const Operation& op, const T& x){
	typedef typename Operation::second_argument_type arg2_type;
	return _binder2nd<Operation>(op, arg2_type(x));
}

/***********************************************************************
**ܣһķж
**ߣ                                                                   
***********************************************************************/
template<class Predicate>
class _unary_negate : public _unary_function<typename Predicate::argument_type, bool>{
protected:
	Predicate pred; //νʵº
public:
	explicit _unary_negate(const Predicate& x): pred(x){}
	bool operator()(const typename Predicate::argument_type &x)const {
		return !pred(x);
	}
};

template<class Predicate>
inline _unary_negate<Predicate> _not1(const Predicate& pred){
	return _unary_negate<Predicate>(pred);
}

/***********************************************************************
**ܣķж
**ߣ                                                                   
***********************************************************************/
template<class Predicate>
class _binary_negate : public _binary_function<typename Predicate::first_argument_type,typename Predicate::second_argument_type, bool>{
protected:
	Predicate pred; //νʵº
public:
	explicit _binary_negate(const Predicate& x): pred(x){}
	bool operator()(const typename Predicate::first_argument_type& x,typename Predicate::second_argument_type& y)const {
		return !pred(x, y);
	}
};

template<class Predicate>
inline _binary_negate<Predicate> _not2(const Predicate& pred){
	return _binary_negate<Predicate>(pred);
}